#pragma once

#include "CoreMinimal.h"
#include "CoreBaseUserWidget.h"
#include "StoreContentViewData.h"
#include "CoreStoreFeaturedContentContainerWidget.generated.h"

class UCoreStoreContentWidget;
class UCoreButtonWidget;
class UCorePaginationContainerWidget;
class UCoreSelectableButtonWidget;

UCLASS(Blueprintable, EditInlineNew)
class UCoreStoreFeaturedContentContainerWidget : public UCoreBaseUserWidget
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, NoClear, meta=(AllowPrivateAccess=true))
	float _contentWidgetScale;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, NoClear, meta=(AllowPrivateAccess=true))
	float _autoAdvanceRate;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, NoClear, meta=(AllowPrivateAccess=true))
	float _autoAdvanceFirstDelay;

	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCoreStoreContentWidget* ContentTile;

	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCoreButtonWidget* PreviousArrow;

	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCoreButtonWidget* NextArrow;

	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCorePaginationContainerWidget* IndexIndicatorContainer;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TArray<FStoreContentViewData> _cachedData;

private:
	UFUNCTION(BlueprintCallable)
	void OnStoreContentUnhovered(UCoreButtonWidget* buttonTarget);

	UFUNCTION(BlueprintCallable)
	void OnStoreContentHovered(UCoreButtonWidget* buttonTarget);

	UFUNCTION(BlueprintCallable)
	void OnStoreContentClicked(const FStoreContentViewData& storeContentViewData);

	UFUNCTION(BlueprintCallable)
	void OnPreviousArrowClicked(UCoreButtonWidget* buttonTarget);

	UFUNCTION(BlueprintCallable)
	void OnNextArrowClicked(UCoreButtonWidget* buttonTarget);

	UFUNCTION(BlueprintCallable)
	void OnIndicatorSelected(UCoreSelectableButtonWidget* selectedButton);

	UFUNCTION(BlueprintCallable)
	void OnIndicatorClicked(UCoreButtonWidget* buttonTarget);

public:
	UCoreStoreFeaturedContentContainerWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreStoreFeaturedContentContainerWidget) { return 0; }
